using TestServer.Services;

var builder = WebApplication.CreateBuilder(args);

builder.Services.AddGrpc();

var app = builder.Build();

app.UseRouting();

app.UseEndpoints
(
    endpoints =>
    {
        endpoints.MapGrpcService<WeatherForecastService>();
    }
);

app.Run();