using Google.Protobuf.WellKnownTypes;

using Grpc.Core;

namespace TestServer.Services
{
    /// <summary>
    /// ϱ⿹ 
    /// </summary>
    public class WeatherForecastService : WeatherForecastProto.WeatherForecastProtoBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ΰ
        /// </summary>
        private readonly ILogger<WeatherForecastService> logger;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - WeatherForecastService(logger)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="logger">ΰ</param>
        public WeatherForecastService(ILogger<WeatherForecastService> logger) => this.logger = logger;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  Ʈ ϱ - GetWeatherStream(_, responseStream, context)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="_">_</param>
        /// <param name="responseStream"> Ʈ</param>
        /// <param name="context">ؽƮ</param>
        /// <returns>½ũ</returns>
        public override async Task GetWeatherStream(Empty _, IServerStreamWriter<WeatherForecastModel> responseStream, ServerCallContext context)
        {
            Random random = new Random();

            DateTime currentTime = DateTime.UtcNow;

            int i = 0;

            while(!context.CancellationToken.IsCancellationRequested && i < 20)
            {
                await Task.Delay(500);

                WeatherForecastModel weatherForecast = new WeatherForecastModel
                {
                    DateTimeStamp = Timestamp.FromDateTime(currentTime.AddDays(i++)),
                    TemperatureC  = random.Next(-20, 55),
                    Summary       = string.Empty
                };

                logger.LogInformation("Sending WeatherData response");

                await responseStream.WriteAsync(weatherForecast);
            }
        }

        #endregion
    }
}